List (Java SE 26 & JDK 26)
Description: declaration: module: java.desktop, package: java.awt, class: List
Keywords: java.awt.List class

# Class List

java.lang.Object
java.awt.Component
java.awt.List

All Implemented Interfaces:
  `ImageObserver, ItemSelectable, MenuContainer, Serializable, Accessible`

public class List extends Component implements ItemSelectable, Accessible
The `List` component presents the user with a scrolling list of text items. The list can be set up so that the user can choose either one item or multiple items.

For example, the code . . .

>     List lst = new List(4, false);
>     lst.add("Mercury");
>     lst.add("Venus");
>     lst.add("Earth");
>     lst.add("JavaSoft");
>     lst.add("Mars");
>     lst.add("Jupiter");
>     lst.add("Saturn");
>     lst.add("Uranus");
>     lst.add("Neptune");
>     lst.add("Pluto");
>     cnt.add(lst);

where `cnt` is a container, produces the following scrolling list:

If the List allows multiple selections, then clicking on an item that is already selected deselects it. In the preceding example, only one item from the scrolling list can be selected at a time, since the second argument when creating the new scrolling list is `false`. If the List does not allow multiple selections, selecting an item causes any other selected item to be deselected.

Note that the list in the example shown was created with four visible rows. Once the list has been created, the number of visible rows cannot be changed. A default `List` is created with four rows, so that `lst = new List()` is equivalent to `list = new List(4, false)`.

Beginning with Java 1.1, the Abstract Window Toolkit sends the `List` object all mouse, keyboard, and focus events that occur over it. (The old AWT event model is being maintained only for backwards compatibility, and its use is discouraged.)

When an item is selected or deselected by the user, AWT sends an instance of `ItemEvent` to the list. When the user double-clicks on an item in a scrolling list, AWT sends an instance of `ActionEvent` to the list following the item event. AWT also generates an action event when the user presses the return key while an item in the list is selected.

If an application wants to perform some action based on an item in this list being selected or activated by the user, it should implement `ItemListener` or `ActionListener` as appropriate and register the new listener to receive events from this list.

For multiple-selection scrolling lists, it is considered a better user interface to use an external gesture (such as clicking on a button) to trigger the action.

Since:
  1.0
See Also:
  - `ItemEvent`
  - `ItemListener`
  - `ActionEvent`
  - `ActionListener`
  - Serialized Form

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `protected class`
  `List.AccessibleAWTList`
  This class implements accessibility support for the `List` class.

  ### Nested classes/interfaces declared in class Component

  `Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`
  Modifier and Type
  Class
  Description
  `protected class`
  `Component.AccessibleAWTComponent`
  Inner class of Component used to provide default support for accessibility.
  `static enum`
  `Component.BaselineResizeBehavior`
  Enumeration of the common ways the baseline of a component can change as the size changes.
  `protected class`
  `Component.BltBufferStrategy`
  Inner class for blitting offscreen surfaces to a component.
  `protected class`
  `Component.FlipBufferStrategy`
  Inner class for flipping buffers on a component.

- ## Field Summary

  ### Fields declared in class Component

  `accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`
  Modifier and Type
  Field
  Description
  `protected AccessibleContext`
  `accessibleContext`
  The `AccessibleContext` associated with this `Component`.
  `static final float`
  `BOTTOM_ALIGNMENT`
  Ease-of-use constant for `getAlignmentY`.
  `static final float`
  `CENTER_ALIGNMENT`
  Ease-of-use constant for `getAlignmentY` and `getAlignmentX`.
  `static final float`
  `LEFT_ALIGNMENT`
  Ease-of-use constant for `getAlignmentX`.
  `static final float`
  `RIGHT_ALIGNMENT`
  Ease-of-use constant for `getAlignmentX`.
  `static final float`
  `TOP_ALIGNMENT`
  Ease-of-use constant for `getAlignmentY()`.

  ### Fields declared in interface ImageObserver

  `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`
  Modifier and Type
  Field
  Description
  `static final int`
  `ABORT`
  This flag in the infoflags argument to imageUpdate indicates that an image which was being tracked asynchronously was aborted before production was complete.
  `static final int`
  `ALLBITS`
  This flag in the infoflags argument to imageUpdate indicates that a static image which was previously drawn is now complete and can be drawn again in its final form.
  `static final int`
  `ERROR`
  This flag in the infoflags argument to imageUpdate indicates that an image which was being tracked asynchronously has encountered an error.
  `static final int`
  `FRAMEBITS`
  This flag in the infoflags argument to imageUpdate indicates that another complete frame of a multi-frame image which was previously drawn is now available to be drawn again.
  `static final int`
  `HEIGHT`
  This flag in the infoflags argument to imageUpdate indicates that the height of the base image is now available and can be taken from the height argument to the imageUpdate callback method.
  `static final int`
  `PROPERTIES`
  This flag in the infoflags argument to imageUpdate indicates that the properties of the image are now available.
  `static final int`
  `SOMEBITS`
  This flag in the infoflags argument to imageUpdate indicates that more pixels needed for drawing a scaled variation of the image are available.
  `static final int`
  `WIDTH`
  This flag in the infoflags argument to imageUpdate indicates that the width of the base image is now available and can be taken from the width argument to the imageUpdate callback method.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `List()`
  Creates a new scrolling list.
  `List(int rows)`
  Creates a new scrolling list initialized with the specified number of visible lines.
  `List(int rows, boolean multipleMode)`
  Creates a new scrolling list initialized to display the specified number of rows.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `add(String item)`
  Adds the specified item to the end of scrolling list.
  `void`
  `add(String item, int index)`
  Adds the specified item to the scrolling list at the position indicated by the index.
  `void`
  `addActionListener(ActionListener l)`
  Adds the specified action listener to receive action events from this list.
  `void`
  `addItem(String item)`
  Deprecated.
  replaced by `add(String)`.
  `void`
  `addItem(String item, int index)`
  Deprecated.
  replaced by `add(String, int)`.
  `void`
  `addItemListener(ItemListener l)`
  Adds the specified item listener to receive item events from this list.
  `void`
  `addNotify()`
  Creates the peer for the list.
  `boolean`
  `allowsMultipleSelections()`
  Deprecated.
  As of JDK version 1.1, replaced by `isMultipleMode()`.
  `void`
  `clear()`
  Deprecated.
  As of JDK version 1.1, replaced by `removeAll()`.
  `int`
  `countItems()`
  Deprecated.
  As of JDK version 1.1, replaced by `getItemCount()`.
  `void`
  `delItem(int position)`
  Deprecated.
  replaced by `remove(String)` and `remove(int)`.
  `void`
  `delItems(int start, int end)`
  Deprecated.
  As of JDK version 1.1, Not for public use in the future.
  `void`
  `deselect(int index)`
  Deselects the item at the specified index.
  `AccessibleContext`
  `getAccessibleContext()`
  Gets the `AccessibleContext` associated with this `List`.
  `ActionListener[]`
  `getActionListeners()`
  Returns an array of all the action listeners registered on this list.
  `String`
  `getItem(int index)`
  Gets the item associated with the specified index.
  `int`
  `getItemCount()`
  Gets the number of items in the list.
  `ItemListener[]`
  `getItemListeners()`
  Returns an array of all the item listeners registered on this list.
  `String[]`
  `getItems()`
  Gets the items in the list.
  `<T extends EventListener>
  T[]`
  `getListeners(Class<T> listenerType)`
  Returns an array of all the objects currently registered as `FooListener`s upon this `List`.
  `Dimension`
  `getMinimumSize()`
  Determines the minimum size of this scrolling list.
  `Dimension`
  `getMinimumSize(int rows)`
  Gets the minimum dimensions for a list with the specified number of rows.
  `Dimension`
  `getPreferredSize()`
  Gets the preferred size of this scrolling list.
  `Dimension`
  `getPreferredSize(int rows)`
  Gets the preferred dimensions for a list with the specified number of rows.
  `int`
  `getRows()`
  Gets the number of visible lines in this list.
  `int`
  `getSelectedIndex()`
  Gets the index of the selected item on the list,
  `int[]`
  `getSelectedIndexes()`
  Gets the selected indexes on the list.
  `String`
  `getSelectedItem()`
  Gets the selected item on this scrolling list.
  `String[]`
  `getSelectedItems()`
  Gets the selected items on this scrolling list.
  `Object[]`
  `getSelectedObjects()`
  Gets the selected items on this scrolling list in an array of Objects.
  `int`
  `getVisibleIndex()`
  Gets the index of the item that was last made visible by the method `makeVisible`.
  `boolean`
  `isIndexSelected(int index)`
  Determines if the specified item in this scrolling list is selected.
  `boolean`
  `isMultipleMode()`
  Determines whether this list allows multiple selections.
  `boolean`
  `isSelected(int index)`
  Deprecated.
  As of JDK version 1.1, replaced by `isIndexSelected(int)`.
  `void`
  `makeVisible(int index)`
  Makes the item at the specified index visible.
  `Dimension`
  `minimumSize()`
  Deprecated.
  As of JDK version 1.1, replaced by `getMinimumSize()`.
  `Dimension`
  `minimumSize(int rows)`
  Deprecated.
  As of JDK version 1.1, replaced by `getMinimumSize(int)`.
  `protected String`
  `paramString()`
  Returns the parameter string representing the state of this scrolling list.
  `Dimension`
  `preferredSize()`
  Deprecated.
  As of JDK version 1.1, replaced by `getPreferredSize()`.
  `Dimension`
  `preferredSize(int rows)`
  Deprecated.
  As of JDK version 1.1, replaced by `getPreferredSize(int)`.
  `protected void`
  `processActionEvent(ActionEvent e)`
  Processes action events occurring on this component by dispatching them to any registered `ActionListener` objects.
  `protected void`
  `processEvent(AWTEvent e)`
  Processes events on this scrolling list.
  `protected void`
  `processItemEvent(ItemEvent e)`
  Processes item events occurring on this list by dispatching them to any registered `ItemListener` objects.
  `void`
  `remove(int position)`
  Removes the item at the specified position from this scrolling list.
  `void`
  `remove(String item)`
  Removes the first occurrence of an item from the list.
  `void`
  `removeActionListener(ActionListener l)`
  Removes the specified action listener so that it no longer receives action events from this list.
  `void`
  `removeAll()`
  Removes all items from this list.
  `void`
  `removeItemListener(ItemListener l)`
  Removes the specified item listener so that it no longer receives item events from this list.
  `void`
  `removeNotify()`
  Removes the peer for this list.
  `void`
  `replaceItem(String newValue, int index)`
  Replaces the item at the specified index in the scrolling list with the new string.
  `void`
  `select(int index)`
  Selects the item at the specified index in the scrolling list.
  `void`
  `setMultipleMode(boolean b)`
  Sets the flag that determines whether this list allows multiple selections.
  `void`
  `setMultipleSelections(boolean b)`
  Deprecated.
  As of JDK version 1.1, replaced by `setMultipleMode(boolean)`.

  ### Methods declared in class Component

  `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, bounds, checkImage, checkImage, coalesceEvents, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, deliverEvent, disable, disableEvents, dispatchEvent, doLayout, enable, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getAlignmentX, getAlignmentY, getBackground, getBaseline, getBaselineResizeBehavior, getBounds, getBounds, getColorModel, getComponentAt, getComponentAt, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeys, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphics, getGraphicsConfiguration, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocation, getLocationOnScreen, getMaximumSize, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getToolkit, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, invalidate, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusCycleRoot, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isOpaque, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, layout, list, list, list, list, list, locate, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paint, paintAll, postEvent, prepareImage, prepareImage, print, printAll, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, repaint, requestFocus, requestFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, requestFocusInWindow, reshape, resize, resize, revalidate, setBackground, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeys, setFocusTraversalKeysEnabled, setFont, setForeground, setIgnoreRepaint, setLocale, setLocation, setLocation, setMaximumSize, setMinimumSize, setMixingCutoutShape, setName, setPreferredSize, setSize, setSize, setVisible, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle, update, validate`
  Modifier and Type
  Method
  Description
  `boolean`
  `action(Event evt, Object what)`
  Deprecated.
  As of JDK version 1.1, should register this component as ActionListener on component which fires action events.
  `void`
  `add(PopupMenu popup)`
  Adds the specified popup menu to the component.
  `void`
  `addComponentListener(ComponentListener l)`
  Adds the specified component listener to receive component events from this component.
  `void`
  `addFocusListener(FocusListener l)`
  Adds the specified focus listener to receive focus events from this component when this component gains input focus.
  `void`
  `addHierarchyBoundsListener(HierarchyBoundsListener l)`
  Adds the specified hierarchy bounds listener to receive hierarchy bounds events from this component when the hierarchy to which this container belongs changes.
  `void`
  `addHierarchyListener(HierarchyListener l)`
  Adds the specified hierarchy listener to receive hierarchy changed events from this component when the hierarchy to which this container belongs changes.
  `void`
  `addInputMethodListener(InputMethodListener l)`
  Adds the specified input method listener to receive input method events from this component.
  `void`
  `addKeyListener(KeyListener l)`
  Adds the specified key listener to receive key events from this component.
  `void`
  `addMouseListener(MouseListener l)`
  Adds the specified mouse listener to receive mouse events from this component.
  `void`
  `addMouseMotionListener(MouseMotionListener l)`
  Adds the specified mouse motion listener to receive mouse motion events from this component.
  `void`
  `addMouseWheelListener(MouseWheelListener l)`
  Adds the specified mouse wheel listener to receive mouse wheel events from this component.
  `void`
  `addPropertyChangeListener(PropertyChangeListener listener)`
  Adds a PropertyChangeListener to the listener list.
  `void`
  `addPropertyChangeListener(String propertyName, PropertyChangeListener listener)`
  Adds a PropertyChangeListener to the listener list for a specific property.
  `void`
  `applyComponentOrientation(ComponentOrientation orientation)`
  Sets the `ComponentOrientation` property of this component and all components contained within it.
  `boolean`
  `areFocusTraversalKeysSet(int id)`
  Returns whether the Set of focus traversal keys for the given focus traversal operation has been explicitly defined for this Component.
  `Rectangle`
  `bounds()`
  Deprecated.
  As of JDK version 1.1, replaced by `getBounds()`.
  `int`
  `checkImage(Image image, int width, int height, ImageObserver observer)`
  Returns the status of the construction of a screen representation of the specified image.
  `int`
  `checkImage(Image image, ImageObserver observer)`
  Returns the status of the construction of a screen representation of the specified image.
  `protected AWTEvent`
  `coalesceEvents(AWTEvent existingEvent, AWTEvent newEvent)`
  Potentially coalesce an event being posted with an existing event.
  `boolean`
  `contains(int x, int y)`
  Checks whether this component "contains" the specified point, where `x` and `y` are defined to be relative to the coordinate system of this component.
  `boolean`
  `contains(Point p)`
  Checks whether this component "contains" the specified point, where the point's x and y coordinates are defined to be relative to the coordinate system of this component.
  `Image`
  `createImage(int width, int height)`
  Creates an off-screen drawable image to be used for double buffering.
  `Image`
  `createImage(ImageProducer producer)`
  Creates an image from the specified image producer.
  `VolatileImage`
  `createVolatileImage(int width, int height)`
  Creates a volatile off-screen drawable image to be used for double buffering.
  `VolatileImage`
  `createVolatileImage(int width, int height, ImageCapabilities caps)`
  Creates a volatile off-screen drawable image, with the given capabilities.
  `void`
  `deliverEvent(Event e)`
  Deprecated.
  As of JDK version 1.1, replaced by `dispatchEvent(AWTEvent e)`.
  `void`
  `disable()`
  Deprecated.
  As of JDK version 1.1, replaced by `setEnabled(boolean)`.
  `protected final void`
  `disableEvents(long eventsToDisable)`
  Disables the events defined by the specified event mask parameter from being delivered to this component.
  `final void`
  `dispatchEvent(AWTEvent e)`
  Dispatches an event to this component or one of its sub components.
  `void`
  `doLayout()`
  Prompts the layout manager to lay out this component.
  `void`
  `enable()`
  Deprecated.
  As of JDK version 1.1, replaced by `setEnabled(boolean)`.
  `void`
  `enable(boolean b)`
  Deprecated.
  As of JDK version 1.1, replaced by `setEnabled(boolean)`.
  `protected final void`
  `enableEvents(long eventsToEnable)`
  Enables the events defined by the specified event mask parameter to be delivered to this component.
  `void`
  `enableInputMethods(boolean enable)`
  Enables or disables input method support for this component.
  `protected void`
  `firePropertyChange(String propertyName, boolean oldValue, boolean newValue)`
  Support for reporting bound property changes for boolean properties.
  `void`
  `firePropertyChange(String propertyName, byte oldValue, byte newValue)`
  Reports a bound property change.
  `void`
  `firePropertyChange(String propertyName, char oldValue, char newValue)`
  Reports a bound property change.
  `void`
  `firePropertyChange(String propertyName, double oldValue, double newValue)`
  Reports a bound property change.
  `void`
  `firePropertyChange(String propertyName, float oldValue, float newValue)`
  Reports a bound property change.
  `protected void`
  `firePropertyChange(String propertyName, int oldValue, int newValue)`
  Support for reporting bound property changes for integer properties.
  `void`
  `firePropertyChange(String propertyName, long oldValue, long newValue)`
  Reports a bound property change.
  `void`
  `firePropertyChange(String propertyName, short oldValue, short newValue)`
  Reports a bound property change.
  `protected void`
  `firePropertyChange(String propertyName, Object oldValue, Object newValue)`
  Support for reporting bound property changes for Object properties.
  `float`
  `getAlignmentX()`
  Returns the alignment along the x axis.
  `float`
  `getAlignmentY()`
  Returns the alignment along the y axis.
  `Color`
  `getBackground()`
  Gets the background color of this component.
  `int`
  `getBaseline(int width, int height)`
  Returns the baseline.
  `Component.BaselineResizeBehavior`
  `getBaselineResizeBehavior()`
  Returns an enum indicating how the baseline of the component changes as the size changes.
  `Rectangle`
  `getBounds()`
  Gets the bounds of this component in the form of a `Rectangle` object.
  `Rectangle`
  `getBounds(Rectangle rv)`
  Stores the bounds of this component into "return value" rv and return rv.
  `ColorModel`
  `getColorModel()`
  Gets the instance of `ColorModel` used to display the component on the output device.
  `Component`
  `getComponentAt(int x, int y)`
  Determines if this component or one of its immediate subcomponents contains the (x, y) location, and if so, returns the containing component.
  `Component`
  `getComponentAt(Point p)`
  Returns the component or subcomponent that contains the specified point.
  `ComponentListener[]`
  `getComponentListeners()`
  Returns an array of all the component listeners registered on this component.
  `ComponentOrientation`
  `getComponentOrientation()`
  Retrieves the language-sensitive orientation that is to be used to order the elements or text within this component.
  `Cursor`
  `getCursor()`
  Gets the cursor set in the component.
  `DropTarget`
  `getDropTarget()`
  Gets the `DropTarget` associated with this `Component`.
  `Container`
  `getFocusCycleRootAncestor()`
  Returns the Container which is the focus cycle root of this Component's focus traversal cycle.
  `FocusListener[]`
  `getFocusListeners()`
  Returns an array of all the focus listeners registered on this component.
  `Set<AWTKeyStroke>`
  `getFocusTraversalKeys(int id)`
  Returns the Set of focus traversal keys for a given traversal operation for this Component.
  `boolean`
  `getFocusTraversalKeysEnabled()`
  Returns whether focus traversal keys are enabled for this Component.
  `Font`
  `getFont()`
  Gets the font of this component.
  `FontMetrics`
  `getFontMetrics(Font font)`
  Gets the font metrics for the specified font.
  `Color`
  `getForeground()`
  Gets the foreground color of this component.
  `Graphics`
  `getGraphics()`
  Creates a graphics context for this component.
  `GraphicsConfiguration`
  `getGraphicsConfiguration()`
  Gets the `GraphicsConfiguration` associated with this `Component`.
  `int`
  `getHeight()`
  Returns the current height of this component.
  `HierarchyBoundsListener[]`
  `getHierarchyBoundsListeners()`
  Returns an array of all the hierarchy bounds listeners registered on this component.
  `HierarchyListener[]`
  `getHierarchyListeners()`
  Returns an array of all the hierarchy listeners registered on this component.
  `boolean`
  `getIgnoreRepaint()`
  Returns whether or not paint messages received from the operating system should be ignored.
  `InputContext`
  `getInputContext()`
  Gets the input context used by this component for handling the communication with input methods when text is entered in this component.
  `InputMethodListener[]`
  `getInputMethodListeners()`
  Returns an array of all the input method listeners registered on this component.
  `InputMethodRequests`
  `getInputMethodRequests()`
  Gets the input method request handler which supports requests from input methods for this component.
  `KeyListener[]`
  `getKeyListeners()`
  Returns an array of all the key listeners registered on this component.
  `Locale`
  `getLocale()`
  Gets the locale of this component.
  `Point`
  `getLocation()`
  Gets the location of this component in the form of a point specifying the component's top-left corner.
  `Point`
  `getLocation(Point rv)`
  Stores the x,y origin of this component into "return value" rv and return rv.
  `Point`
  `getLocationOnScreen()`
  Gets the location of this component in the form of a point specifying the component's top-left corner in the screen's coordinate space.
  `Dimension`
  `getMaximumSize()`
  Gets the maximum size of this component.
  `MouseListener[]`
  `getMouseListeners()`
  Returns an array of all the mouse listeners registered on this component.
  `MouseMotionListener[]`
  `getMouseMotionListeners()`
  Returns an array of all the mouse motion listeners registered on this component.
  `Point`
  `getMousePosition()`
  Returns the position of the mouse pointer in this `Component`'s coordinate space if the `Component` is directly under the mouse pointer, otherwise returns `null`.
  `MouseWheelListener[]`
  `getMouseWheelListeners()`
  Returns an array of all the mouse wheel listeners registered on this component.
  `String`
  `getName()`
  Gets the name of the component.
  `Container`
  `getParent()`
  Gets the parent of this component.
  `PropertyChangeListener[]`
  `getPropertyChangeListeners()`
  Returns an array of all the property change listeners registered on this component.
  `PropertyChangeListener[]`
  `getPropertyChangeListeners(String propertyName)`
  Returns an array of all the listeners which have been associated with the named property.
  `Dimension`
  `getSize()`
  Returns the size of this component in the form of a `Dimension` object.
  `Dimension`
  `getSize(Dimension rv)`
  Stores the width/height of this component into "return value" rv and return rv.
  `Toolkit`
  `getToolkit()`
  Gets the toolkit of this component.
  `final Object`
  `getTreeLock()`
  Gets this component's locking object (the object that owns the thread synchronization monitor) for AWT component-tree and layout operations.
  `int`
  `getWidth()`
  Returns the current width of this component.
  `int`
  `getX()`
  Returns the current x coordinate of the components origin.
  `int`
  `getY()`
  Returns the current y coordinate of the components origin.
  `boolean`
  `gotFocus(Event evt, Object what)`
  Deprecated.
  As of JDK version 1.1, replaced by processFocusEvent(FocusEvent).
  `boolean`
  `handleEvent(Event evt)`
  Deprecated.
  As of JDK version 1.1 replaced by processEvent(AWTEvent).
  `boolean`
  `hasFocus()`
  Returns `true` if this `Component` is the focus owner.
  `void`
  `hide()`
  Deprecated.
  As of JDK version 1.1, replaced by `setVisible(boolean)`.
  `boolean`
  `imageUpdate(Image img, int infoflags, int x, int y, int w, int h)`
  Repaints the component when the image has changed.
  `boolean`
  `inside(int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by contains(int, int).
  `void`
  `invalidate()`
  Invalidates this component and its ancestors.
  `boolean`
  `isBackgroundSet()`
  Returns whether the background color has been explicitly set for this Component.
  `boolean`
  `isCursorSet()`
  Returns whether the cursor has been explicitly set for this Component.
  `boolean`
  `isDisplayable()`
  Determines whether this component is displayable.
  `boolean`
  `isDoubleBuffered()`
  Returns true if this component is painted to an offscreen image ("buffer") that's copied to the screen later.
  `boolean`
  `isEnabled()`
  Determines whether this component is enabled.
  `boolean`
  `isFocusable()`
  Returns whether this Component can be focused.
  `boolean`
  `isFocusCycleRoot(Container container)`
  Returns whether the specified Container is the focus cycle root of this Component's focus traversal cycle.
  `boolean`
  `isFocusOwner()`
  Returns `true` if this `Component` is the focus owner.
  `boolean`
  `isFocusTraversable()`
  Deprecated.
  As of 1.4, replaced by `isFocusable()`.
  `boolean`
  `isFontSet()`
  Returns whether the font has been explicitly set for this Component.
  `boolean`
  `isForegroundSet()`
  Returns whether the foreground color has been explicitly set for this Component.
  `boolean`
  `isLightweight()`
  A lightweight component doesn't have a native toolkit peer.
  `boolean`
  `isMaximumSizeSet()`
  Returns true if the maximum size has been set to a non-`null` value otherwise returns false.
  `boolean`
  `isMinimumSizeSet()`
  Returns whether or not `setMinimumSize` has been invoked with a non-null value.
  `boolean`
  `isOpaque()`
  Returns true if this component is completely opaque, returns false by default.
  `boolean`
  `isPreferredSizeSet()`
  Returns true if the preferred size has been set to a non-`null` value otherwise returns false.
  `boolean`
  `isShowing()`
  Determines whether this component is showing on screen.
  `boolean`
  `isValid()`
  Determines whether this component is valid.
  `boolean`
  `isVisible()`
  Determines whether this component should be visible when its parent is visible.
  `boolean`
  `keyDown(Event evt, int key)`
  Deprecated.
  As of JDK version 1.1, replaced by processKeyEvent(KeyEvent).
  `boolean`
  `keyUp(Event evt, int key)`
  Deprecated.
  As of JDK version 1.1, replaced by processKeyEvent(KeyEvent).
  `void`
  `layout()`
  Deprecated.
  As of JDK version 1.1, replaced by `doLayout()`.
  `void`
  `list()`
  Prints a listing of this component to the standard system output stream `System.out`.
  `void`
  `list(PrintStream out)`
  Prints a listing of this component to the specified output stream.
  `void`
  `list(PrintStream out, int indent)`
  Prints out a list, starting at the specified indentation, to the specified print stream.
  `void`
  `list(PrintWriter out)`
  Prints a listing to the specified print writer.
  `void`
  `list(PrintWriter out, int indent)`
  Prints out a list, starting at the specified indentation, to the specified print writer.
  `Component`
  `locate(int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by getComponentAt(int, int).
  `Point`
  `location()`
  Deprecated.
  As of JDK version 1.1, replaced by `getLocation()`.
  `boolean`
  `lostFocus(Event evt, Object what)`
  Deprecated.
  As of JDK version 1.1, replaced by processFocusEvent(FocusEvent).
  `boolean`
  `mouseDown(Event evt, int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
  `boolean`
  `mouseDrag(Event evt, int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by processMouseMotionEvent(MouseEvent).
  `boolean`
  `mouseEnter(Event evt, int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
  `boolean`
  `mouseExit(Event evt, int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
  `boolean`
  `mouseMove(Event evt, int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by processMouseMotionEvent(MouseEvent).
  `boolean`
  `mouseUp(Event evt, int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
  `void`
  `move(int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by `setLocation(int, int)`.
  `void`
  `nextFocus()`
  Deprecated.
  As of JDK version 1.1, replaced by transferFocus().
  `void`
  `paint(Graphics g)`
  Paints this component.
  `void`
  `paintAll(Graphics g)`
  Paints this component and all of its subcomponents.
  `boolean`
  `postEvent(Event e)`
  Deprecated.
  As of JDK version 1.1, replaced by dispatchEvent(AWTEvent).
  `boolean`
  `prepareImage(Image image, int width, int height, ImageObserver observer)`
  Prepares an image for rendering on this component at the specified width and height.
  `boolean`
  `prepareImage(Image image, ImageObserver observer)`
  Prepares an image for rendering on this component.
  `void`
  `print(Graphics g)`
  Prints this component.
  `void`
  `printAll(Graphics g)`
  Prints this component and all of its subcomponents.
  `protected void`
  `processComponentEvent(ComponentEvent e)`
  Processes component events occurring on this component by dispatching them to any registered `ComponentListener` objects.
  `protected void`
  `processFocusEvent(FocusEvent e)`
  Processes focus events occurring on this component by dispatching them to any registered `FocusListener` objects.
  `protected void`
  `processHierarchyBoundsEvent(HierarchyEvent e)`
  Processes hierarchy bounds events occurring on this component by dispatching them to any registered `HierarchyBoundsListener` objects.
  `protected void`
  `processHierarchyEvent(HierarchyEvent e)`
  Processes hierarchy events occurring on this component by dispatching them to any registered `HierarchyListener` objects.
  `protected void`
  `processInputMethodEvent(InputMethodEvent e)`
  Processes input method events occurring on this component by dispatching them to any registered `InputMethodListener` objects.
  `protected void`
  `processKeyEvent(KeyEvent e)`
  Processes key events occurring on this component by dispatching them to any registered `KeyListener` objects.
  `protected void`
  `processMouseEvent(MouseEvent e)`
  Processes mouse events occurring on this component by dispatching them to any registered `MouseListener` objects.
  `protected void`
  `processMouseMotionEvent(MouseEvent e)`
  Processes mouse motion events occurring on this component by dispatching them to any registered `MouseMotionListener` objects.
  `protected void`
  `processMouseWheelEvent(MouseWheelEvent e)`
  Processes mouse wheel events occurring on this component by dispatching them to any registered `MouseWheelListener` objects.
  `void`
  `remove(MenuComponent popup)`
  Removes the specified popup menu from the component.
  `void`
  `removeComponentListener(ComponentListener l)`
  Removes the specified component listener so that it no longer receives component events from this component.
  `void`
  `removeFocusListener(FocusListener l)`
  Removes the specified focus listener so that it no longer receives focus events from this component.
  `void`
  `removeHierarchyBoundsListener(HierarchyBoundsListener l)`
  Removes the specified hierarchy bounds listener so that it no longer receives hierarchy bounds events from this component.
  `void`
  `removeHierarchyListener(HierarchyListener l)`
  Removes the specified hierarchy listener so that it no longer receives hierarchy changed events from this component.
  `void`
  `removeInputMethodListener(InputMethodListener l)`
  Removes the specified input method listener so that it no longer receives input method events from this component.
  `void`
  `removeKeyListener(KeyListener l)`
  Removes the specified key listener so that it no longer receives key events from this component.
  `void`
  `removeMouseListener(MouseListener l)`
  Removes the specified mouse listener so that it no longer receives mouse events from this component.
  `void`
  `removeMouseMotionListener(MouseMotionListener l)`
  Removes the specified mouse motion listener so that it no longer receives mouse motion events from this component.
  `void`
  `removeMouseWheelListener(MouseWheelListener l)`
  Removes the specified mouse wheel listener so that it no longer receives mouse wheel events from this component.
  `void`
  `removePropertyChangeListener(PropertyChangeListener listener)`
  Removes a PropertyChangeListener from the listener list.
  `void`
  `removePropertyChangeListener(String propertyName, PropertyChangeListener listener)`
  Removes a `PropertyChangeListener` from the listener list for a specific property.
  `void`
  `repaint()`
  Repaints this component.
  `void`
  `repaint(int x, int y, int width, int height)`
  Repaints the specified rectangle of this component.
  `void`
  `repaint(long tm)`
  Repaints the component.
  `void`
  `repaint(long tm, int x, int y, int width, int height)`
  Repaints the specified rectangle of this component within `tm` milliseconds.
  `void`
  `requestFocus()`
  Requests that this Component get the input focus, and that this Component's top-level ancestor become the focused Window.
  `protected boolean`
  `requestFocus(boolean temporary)`
  Requests that this `Component` get the input focus, and that this `Component`'s top-level ancestor become the focused `Window`.
  `protected boolean`
  `requestFocus(boolean temporary, FocusEvent.Cause cause)`
  Requests by the reason of `cause` that this `Component` get the input focus, and that this `Component`'s top-level ancestor become the focused `Window`.
  `void`
  `requestFocus(FocusEvent.Cause cause)`
  Requests by the reason of `cause` that this Component get the input focus, and that this Component's top-level ancestor become the focused Window.
  `boolean`
  `requestFocusInWindow()`
  Requests that this Component get the input focus, if this Component's top-level ancestor is already the focused Window.
  `protected boolean`
  `requestFocusInWindow(boolean temporary)`
  Requests that this `Component` get the input focus, if this `Component`'s top-level ancestor is already the focused `Window`.
  `boolean`
  `requestFocusInWindow(FocusEvent.Cause cause)`
  Requests by the reason of `cause` that this Component get the input focus, if this Component's top-level ancestor is already the focused Window.
  `void`
  `reshape(int x, int y, int width, int height)`
  Deprecated.
  As of JDK version 1.1, replaced by `setBounds(int, int, int, int)`.
  `void`
  `resize(int width, int height)`
  Deprecated.
  As of JDK version 1.1, replaced by `setSize(int, int)`.
  `void`
  `resize(Dimension d)`
  Deprecated.
  As of JDK version 1.1, replaced by `setSize(Dimension)`.
  `void`
  `revalidate()`
  Revalidates the component hierarchy up to the nearest validate root.
  `void`
  `setBackground(Color c)`
  Sets the background color of this component.
  `void`
  `setBounds(int x, int y, int width, int height)`
  Moves and resizes this component.
  `void`
  `setBounds(Rectangle r)`
  Moves and resizes this component to conform to the new bounding rectangle `r`.
  `void`
  `setComponentOrientation(ComponentOrientation o)`
  Sets the language-sensitive orientation that is to be used to order the elements or text within this component.
  `void`
  `setCursor(Cursor cursor)`
  Sets the cursor image to the specified cursor.
  `void`
  `setDropTarget(DropTarget dt)`
  Associate a `DropTarget` with this component.
  `void`
  `setEnabled(boolean b)`
  Enables or disables this component, depending on the value of the parameter `b`.
  `void`
  `setFocusable(boolean focusable)`
  Sets the focusable state of this Component to the specified value.
  `void`
  `setFocusTraversalKeys(int id, Set<? extends AWTKeyStroke> keystrokes)`
  Sets the focus traversal keys for a given traversal operation for this Component.
  `void`
  `setFocusTraversalKeysEnabled(boolean focusTraversalKeysEnabled)`
  Sets whether focus traversal keys are enabled for this Component.
  `void`
  `setFont(Font f)`
  Sets the font of this component.
  `void`
  `setForeground(Color c)`
  Sets the foreground color of this component.
  `void`
  `setIgnoreRepaint(boolean ignoreRepaint)`
  Sets whether or not paint messages received from the operating system should be ignored.
  `void`
  `setLocale(Locale l)`
  Sets the locale of this component.
  `void`
  `setLocation(int x, int y)`
  Moves this component to a new location.
  `void`
  `setLocation(Point p)`
  Moves this component to a new location.
  `void`
  `setMaximumSize(Dimension maximumSize)`
  Sets the maximum size of this component to a constant value.
  `void`
  `setMinimumSize(Dimension minimumSize)`
  Sets the minimum size of this component to a constant value.
  `void`
  `setMixingCutoutShape(Shape shape)`
  Sets a 'mixing-cutout' shape for this lightweight component.
  `void`
  `setName(String name)`
  Sets the name of the component to the specified string.
  `void`
  `setPreferredSize(Dimension preferredSize)`
  Sets the preferred size of this component to a constant value.
  `void`
  `setSize(int width, int height)`
  Resizes this component so that it has width `width` and height `height`.
  `void`
  `setSize(Dimension d)`
  Resizes this component so that it has width `d.width` and height `d.height`.
  `void`
  `setVisible(boolean b)`
  Shows or hides this component depending on the value of parameter `b`.
  `void`
  `show()`
  Deprecated.
  As of JDK version 1.1, replaced by `setVisible(boolean)`.
  `void`
  `show(boolean b)`
  Deprecated.
  As of JDK version 1.1, replaced by `setVisible(boolean)`.
  `Dimension`
  `size()`
  Deprecated.
  As of JDK version 1.1, replaced by `getSize()`.
  `String`
  `toString()`
  Returns a string representation of this component and its values.
  `void`
  `transferFocus()`
  Transfers the focus to the next component, as though this Component were the focus owner.
  `void`
  `transferFocusBackward()`
  Transfers the focus to the previous component, as though this Component were the focus owner.
  `void`
  `transferFocusUpCycle()`
  Transfers the focus up one focus traversal cycle.
  `void`
  `update(Graphics g)`
  Updates this component.
  `void`
  `validate()`
  Validates this component.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### List

    public List() throws HeadlessException
    Creates a new scrolling list. By default, there are four visible lines and multiple selections are not allowed. Note that this is a convenience method for `List(0, false)`. Also note that the number of visible lines in the list cannot be changed after it has been created.
    Throws:
      `HeadlessException` - if GraphicsEnvironment.isHeadless() returns true.
    See Also:
      - `GraphicsEnvironment.isHeadless()`

  - ### List

    public List(int rows) throws HeadlessException
    Creates a new scrolling list initialized with the specified number of visible lines. By default, multiple selections are not allowed. Note that this is a convenience method for `List(rows, false)`. Also note that the number of visible rows in the list cannot be changed after it has been created.
    Parameters:
      `rows` - the number of items to show.
    Throws:
      `HeadlessException` - if GraphicsEnvironment.isHeadless() returns true.
    Since:
      1.1
    See Also:
      - `GraphicsEnvironment.isHeadless()`

  - ### List

    public List(int rows, boolean multipleMode) throws HeadlessException
    Creates a new scrolling list initialized to display the specified number of rows. Note that if zero rows are specified, then the list will be created with a default of four rows. Also note that the number of visible rows in the list cannot be changed after it has been created. If the value of `multipleMode` is `true`, then the user can select multiple items from the list. If it is `false`, only one item at a time can be selected.
    Parameters:
      `rows` - the number of items to show.
      `multipleMode` - if `true`, then multiple selections are allowed; otherwise, only one item can be selected at a time.
    Throws:
      `HeadlessException` - if GraphicsEnvironment.isHeadless() returns true.
    See Also:
      - `GraphicsEnvironment.isHeadless()`

- ## Method Details

  - ### addNotify

    public void addNotify()
    Creates the peer for the list. The peer allows us to modify the list's appearance without changing its functionality.
    Overrides:
      `addNotify` in class `Component`
    See Also:
      - `Component.isDisplayable()`
      - `Component.removeNotify()`
      - `Component.invalidate()`

  - ### removeNotify

    public void removeNotify()
    Removes the peer for this list. The peer allows us to modify the list's appearance without changing its functionality.
    Overrides:
      `removeNotify` in class `Component`
    See Also:
      - `Component.isDisplayable()`
      - `Component.addNotify()`

  - ### getItemCount

    public int getItemCount()
    Gets the number of items in the list.
    Returns:
      the number of items in the list
    Since:
      1.1
    See Also:
      - `getItem(int)`

  - ### countItems

    @Deprecated public int countItems()
    Deprecated.
    As of JDK version 1.1, replaced by `getItemCount()`.
    Returns the number of items in the list.
    Returns:
      the number of items in the list

  - ### getItem

    public String getItem(int index)
    Gets the item associated with the specified index.
    Parameters:
      `index` - the position of the item
    Returns:
      an item that is associated with the specified index
    See Also:
      - `getItemCount()`

  - ### getItems

    public String[] getItems()
    Gets the items in the list.
    Returns:
      a string array containing items of the list
    Since:
      1.1
    See Also:
      - `select(int)`
      - `deselect(int)`
      - `isIndexSelected(int)`

  - ### add

    public void add(String item)
    Adds the specified item to the end of scrolling list.
    Parameters:
      `item` - the item to be added
    Since:
      1.1

  - ### addItem

    @Deprecated public void addItem(String item)
    Deprecated.
    replaced by `add(String)`.
    Adds the specified item to the end of the list.
    Parameters:
      `item` - the item to be added

  - ### add

    public void add(String item, int index)
    Adds the specified item to the scrolling list at the position indicated by the index. The index is zero-based. If the value of the index is less than zero, or if the value of the index is greater than or equal to the number of items in the list, then the item is added to the end of the list.
    Parameters:
      `item` - the item to be added; if this parameter is `null` then the item is treated as an empty string, `""`
      `index` - the position at which to add the item
    Since:
      1.1

  - ### addItem

    @Deprecated public void addItem(String item, int index)
    Deprecated.
    replaced by `add(String, int)`.
    Adds the specified item to the list at the position indicated by the index.
    Parameters:
      `item` - the item to be added
      `index` - the position at which to add the item

  - ### replaceItem

    public void replaceItem(String newValue, int index)
    Replaces the item at the specified index in the scrolling list with the new string.
    Parameters:
      `newValue` - a new string to replace an existing item
      `index` - the position of the item to replace
    Throws:
      `ArrayIndexOutOfBoundsException` - if `index` is out of range

  - ### removeAll

    public void removeAll()
    Removes all items from this list.
    Since:
      1.1
    See Also:
      - `remove(String)`
      - `delItems(int, int)`

  - ### clear

    @Deprecated public void clear()
    Deprecated.
    As of JDK version 1.1, replaced by `removeAll()`.

  - ### remove

    public void remove(String item)
    Removes the first occurrence of an item from the list. If the specified item is selected, and is the only selected item in the list, the list is set to have no selection.
    Parameters:
      `item` - the item to remove from the list
    Throws:
      `IllegalArgumentException` - if the item doesn't exist in the list
    Since:
      1.1

  - ### remove

    public void remove(int position)
    Removes the item at the specified position from this scrolling list. If the item with the specified position is selected, and is the only selected item in the list, the list is set to have no selection.
    Parameters:
      `position` - the index of the item to delete
    Throws:
      `ArrayIndexOutOfBoundsException` - if the `position` is less than 0 or greater than `getItemCount()-1`
    Since:
      1.1
    See Also:
      - `add(String, int)`

  - ### delItem

    @Deprecated public void delItem(int position)
    Deprecated.
    replaced by `remove(String)` and `remove(int)`.
    Removes the item at the specified position.
    Parameters:
      `position` - the index of the item to delete

  - ### getSelectedIndex

    public int getSelectedIndex()
    Gets the index of the selected item on the list,
    Returns:
      the index of the selected item; if no item is selected, or if multiple items are selected, `-1` is returned.
    See Also:
      - `select(int)`
      - `deselect(int)`
      - `isIndexSelected(int)`

  - ### getSelectedIndexes

    public int[] getSelectedIndexes()
    Gets the selected indexes on the list.
    Returns:
      an array of the selected indexes on this scrolling list; if no item is selected, a zero-length array is returned.
    See Also:
      - `select(int)`
      - `deselect(int)`
      - `isIndexSelected(int)`

  - ### getSelectedItem

    public String getSelectedItem()
    Gets the selected item on this scrolling list.
    Returns:
      the selected item on the list; if no item is selected, or if multiple items are selected, `null` is returned.
    See Also:
      - `select(int)`
      - `deselect(int)`
      - `isIndexSelected(int)`

  - ### getSelectedItems

    public String[] getSelectedItems()
    Gets the selected items on this scrolling list.
    Returns:
      an array of the selected items on this scrolling list; if no item is selected, a zero-length array is returned.
    See Also:
      - `select(int)`
      - `deselect(int)`
      - `isIndexSelected(int)`

  - ### getSelectedObjects

    public Object[] getSelectedObjects()
    Gets the selected items on this scrolling list in an array of Objects.
    Specified by:
      `getSelectedObjects` in interface `ItemSelectable`
    Returns:
      an array of `Object`s representing the selected items on this scrolling list; if no item is selected, a zero-length array is returned.
    See Also:
      - `getSelectedItems()`
      - `ItemSelectable`

  - ### select

    public void select(int index)
    Selects the item at the specified index in the scrolling list.

    Note that passing out of range parameters is invalid, and will result in unspecified behavior.

    Note that this method should be primarily used to initially select an item in this component. Programmatically calling this method will not trigger an `ItemEvent`. The only way to trigger an `ItemEvent` is by user interaction.

    Parameters:
      `index` - the position of the item to select
    See Also:
      - `getSelectedItem()`
      - `deselect(int)`
      - `isIndexSelected(int)`

  - ### deselect

    public void deselect(int index)
    Deselects the item at the specified index.

    Note that passing out of range parameters is invalid, and will result in unspecified behavior.

    If the item at the specified index is not selected, then the operation is ignored.

    Parameters:
      `index` - the position of the item to deselect
    See Also:
      - `select(int)`
      - `getSelectedItem()`
      - `isIndexSelected(int)`

  - ### isIndexSelected

    public boolean isIndexSelected(int index)
    Determines if the specified item in this scrolling list is selected.
    Parameters:
      `index` - the item to be checked
    Returns:
      `true` if the specified item has been selected; `false` otherwise
    Since:
      1.1
    See Also:
      - `select(int)`
      - `deselect(int)`

  - ### isSelected

    @Deprecated public boolean isSelected(int index)
    Deprecated.
    As of JDK version 1.1, replaced by `isIndexSelected(int)`.
    Determines if the specified item in the list is selected.
    Parameters:
      `index` - specifies the item to be checked
    Returns:
      `true` if the item is selected; otherwise `false`

  - ### getRows

    public int getRows()
    Gets the number of visible lines in this list. Note that once the `List` has been created, this number will never change.
    Returns:
      the number of visible lines in this scrolling list

  - ### isMultipleMode

    public boolean isMultipleMode()
    Determines whether this list allows multiple selections.
    Returns:
      `true` if this list allows multiple selections; otherwise, `false`
    Since:
      1.1
    See Also:
      - `setMultipleMode(boolean)`

  - ### allowsMultipleSelections

    @Deprecated public boolean allowsMultipleSelections()
    Deprecated.
    As of JDK version 1.1, replaced by `isMultipleMode()`.
    Determines whether this list allows multiple selections.
    Returns:
      `true` if this list allows multiple selections; otherwise `false`

  - ### setMultipleMode

    public void setMultipleMode(boolean b)
    Sets the flag that determines whether this list allows multiple selections. When the selection mode is changed from multiple-selection to single-selection, the selected items change as follows: If a selected item has the location cursor, only that item will remain selected. If no selected item has the location cursor, all items will be deselected.
    Parameters:
      `b` - if `true` then multiple selections are allowed; otherwise, only one item from the list can be selected at once
    Since:
      1.1
    See Also:
      - `isMultipleMode()`

  - ### setMultipleSelections

    @Deprecated public void setMultipleSelections(boolean b)
    Deprecated.
    As of JDK version 1.1, replaced by `setMultipleMode(boolean)`.
    Enables or disables multiple selection mode for this list.
    Parameters:
      `b` - `true` to enable multiple mode, `false` otherwise

  - ### getVisibleIndex

    public int getVisibleIndex()
    Gets the index of the item that was last made visible by the method `makeVisible`.
    Returns:
      the index of the item that was last made visible
    See Also:
      - `makeVisible(int)`

  - ### makeVisible

    public void makeVisible(int index)
    Makes the item at the specified index visible.
    Parameters:
      `index` - the position of the item
    See Also:
      - `getVisibleIndex()`

  - ### getPreferredSize

    public Dimension getPreferredSize(int rows)
    Gets the preferred dimensions for a list with the specified number of rows.
    Parameters:
      `rows` - number of rows in the list
    Returns:
      the preferred dimensions for displaying this scrolling list given that the specified number of rows must be visible
    Since:
      1.1
    See Also:
      - `Component.getPreferredSize()`

  - ### preferredSize

    @Deprecated public Dimension preferredSize(int rows)
    Deprecated.
    As of JDK version 1.1, replaced by `getPreferredSize(int)`.
    Returns the preferred size of this component assuming it has the specified number of rows.
    Parameters:
      `rows` - the number of rows
    Returns:
      the preferred dimensions for displaying this list

  - ### getPreferredSize

    public Dimension getPreferredSize()
    Gets the preferred size of this scrolling list.
    Overrides:
      `getPreferredSize` in class `Component`
    Returns:
      the preferred dimensions for displaying this scrolling list
    Since:
      1.1
    See Also:
      - `Component.getPreferredSize()`

  - ### preferredSize

    @Deprecated public Dimension preferredSize()
    Deprecated.
    As of JDK version 1.1, replaced by `getPreferredSize()`.
    Description copied from class: `Component`
    Returns the component's preferred size.
    Overrides:
      `preferredSize` in class `Component`
    Returns:
      the component's preferred size

  - ### getMinimumSize

    public Dimension getMinimumSize(int rows)
    Gets the minimum dimensions for a list with the specified number of rows.
    Parameters:
      `rows` - number of rows in the list
    Returns:
      the minimum dimensions for displaying this scrolling list given that the specified number of rows must be visible
    Since:
      1.1
    See Also:
      - `Component.getMinimumSize()`

  - ### minimumSize

    @Deprecated public Dimension minimumSize(int rows)
    Deprecated.
    As of JDK version 1.1, replaced by `getMinimumSize(int)`.
    Returns the minimum dimensions for the list with the specified number of rows.
    Parameters:
      `rows` - the number of rows in the list
    Returns:
      the minimum dimensions for displaying this list

  - ### getMinimumSize

    public Dimension getMinimumSize()
    Determines the minimum size of this scrolling list.
    Overrides:
      `getMinimumSize` in class `Component`
    Returns:
      the minimum dimensions needed to display this scrolling list
    Since:
      1.1
    See Also:
      - `Component.getMinimumSize()`

  - ### minimumSize

    @Deprecated public Dimension minimumSize()
    Deprecated.
    As of JDK version 1.1, replaced by `getMinimumSize()`.
    Description copied from class: `Component`
    Returns the minimum size of this component.
    Overrides:
      `minimumSize` in class `Component`
    Returns:
      the minimum size of this component

  - ### addItemListener

    public void addItemListener(ItemListener l)
    Adds the specified item listener to receive item events from this list. Item events are sent in response to user input, but not in response to calls to `select` or `deselect`. If listener `l` is `null`, no exception is thrown and no action is performed.

    Refer to AWT Threading Issues for details on AWT's threading model.

    Specified by:
      `addItemListener` in interface `ItemSelectable`
    Parameters:
      `l` - the item listener
    Since:
      1.1
    See Also:
      - `removeItemListener(ItemListener)`
      - `getItemListeners()`
      - `select(int)`
      - `deselect(int)`
      - `ItemEvent`
      - `ItemListener`

  - ### removeItemListener

    public void removeItemListener(ItemListener l)
    Removes the specified item listener so that it no longer receives item events from this list. If listener `l` is `null`, no exception is thrown and no action is performed.

    Refer to AWT Threading Issues for details on AWT's threading model.

    Specified by:
      `removeItemListener` in interface `ItemSelectable`
    Parameters:
      `l` - the item listener
    Since:
      1.1
    See Also:
      - `addItemListener(ItemListener)`
      - `getItemListeners()`
      - `ItemEvent`
      - `ItemListener`

  - ### getItemListeners

    public ItemListener[] getItemListeners()
    Returns an array of all the item listeners registered on this list.
    Returns:
      all of this list's `ItemListener`s or an empty array if no item listeners are currently registered
    Since:
      1.4
    See Also:
      - `addItemListener(ItemListener)`
      - `removeItemListener(ItemListener)`
      - `ItemEvent`
      - `ItemListener`

  - ### addActionListener

    public void addActionListener(ActionListener l)
    Adds the specified action listener to receive action events from this list. Action events occur when a user double-clicks on a list item or types Enter when the list has the keyboard focus.

    If listener `l` is `null`, no exception is thrown and no action is performed.

    Refer to AWT Threading Issues for details on AWT's threading model.

    Parameters:
      `l` - the action listener
    Since:
      1.1
    See Also:
      - `removeActionListener(ActionListener)`
      - `getActionListeners()`
      - `ActionEvent`
      - `ActionListener`

  - ### removeActionListener

    public void removeActionListener(ActionListener l)
    Removes the specified action listener so that it no longer receives action events from this list. Action events occur when a user double-clicks on a list item. If listener `l` is `null`, no exception is thrown and no action is performed.

    Refer to AWT Threading Issues for details on AWT's threading model.

    Parameters:
      `l` - the action listener
    Since:
      1.1
    See Also:
      - `addActionListener(ActionListener)`
      - `getActionListeners()`
      - `ActionEvent`
      - `ActionListener`

  - ### getActionListeners

    public ActionListener[] getActionListeners()
    Returns an array of all the action listeners registered on this list.
    Returns:
      all of this list's `ActionListener`s or an empty array if no action listeners are currently registered
    Since:
      1.4
    See Also:
      - `addActionListener(ActionListener)`
      - `removeActionListener(ActionListener)`
      - `ActionEvent`
      - `ActionListener`

  - ### getListeners

    public <T extends EventListener> T[] getListeners(Class<T> listenerType)
    Returns an array of all the objects currently registered as `FooListener`s upon this `List`. `FooListener`s are registered using the `addFooListener` method.

    You can specify the `listenerType` argument with a class literal, such as `FooListener.class`. For example, you can query a `List l` for its item listeners with the following code:

        ItemListener[] ils = (ItemListener[])(l.getListeners(ItemListener.class));

    If no such listeners exist, this method returns an empty array.
    Overrides:
      `getListeners` in class `Component`
    Type Parameters:
      `T` - the type of the listeners
    Parameters:
      `listenerType` - the type of listeners requested; this parameter should specify an interface that descends from `java.util.EventListener`
    Returns:
      an array of all objects registered as `FooListener`s on this list, or an empty array if no such listeners have been added
    Throws:
      `ClassCastException` - if `listenerType` doesn't specify a class or interface that implements `java.util.EventListener`
    Since:
      1.3
    See Also:
      - `getItemListeners()`

  - ### processEvent

    protected void processEvent(AWTEvent e)
    Processes events on this scrolling list. If an event is an instance of `ItemEvent`, it invokes the `processItemEvent` method. Else, if the event is an instance of `ActionEvent`, it invokes `processActionEvent`. If the event is not an item event or an action event, it invokes `processEvent` on the superclass.

    Note that if the event parameter is `null` the behavior is unspecified and may result in an exception.

    Overrides:
      `processEvent` in class `Component`
    Parameters:
      `e` - the event
    Since:
      1.1
    See Also:
      - `ActionEvent`
      - `ItemEvent`
      - `processActionEvent(ActionEvent)`
      - `processItemEvent(ItemEvent)`

  - ### processItemEvent

    protected void processItemEvent(ItemEvent e)
    Processes item events occurring on this list by dispatching them to any registered `ItemListener` objects.

    This method is not called unless item events are enabled for this component. Item events are enabled when one of the following occurs:

    - An `ItemListener` object is registered via `addItemListener`.
    - Item events are enabled via `enableEvents`.

    Note that if the event parameter is `null` the behavior is unspecified and may result in an exception.

    Parameters:
      `e` - the item event
    Since:
      1.1
    See Also:
      - `ItemEvent`
      - `ItemListener`
      - `addItemListener(ItemListener)`
      - `Component.enableEvents(long)`

  - ### processActionEvent

    protected void processActionEvent(ActionEvent e)
    Processes action events occurring on this component by dispatching them to any registered `ActionListener` objects.

    This method is not called unless action events are enabled for this component. Action events are enabled when one of the following occurs:

    - An `ActionListener` object is registered via `addActionListener`.
    - Action events are enabled via `enableEvents`.

    Note that if the event parameter is `null` the behavior is unspecified and may result in an exception.

    Parameters:
      `e` - the action event
    Since:
      1.1
    See Also:
      - `ActionEvent`
      - `ActionListener`
      - `addActionListener(ActionListener)`
      - `Component.enableEvents(long)`

  - ### paramString

    protected String paramString()
    Returns the parameter string representing the state of this scrolling list. This string is useful for debugging.
    Overrides:
      `paramString` in class `Component`
    Returns:
      the parameter string of this scrolling list

  - ### delItems

    @Deprecated public void delItems(int start, int end)
    Deprecated.
    As of JDK version 1.1, Not for public use in the future. This method is expected to be retained only as a package private method.
    Deletes the list items in the specified index range.
    Parameters:
      `start` - the beginning index of the range to delete
      `end` - the ending index of the range to delete

  - ### getAccessibleContext

    public AccessibleContext getAccessibleContext()
    Gets the `AccessibleContext` associated with this `List`. For lists, the `AccessibleContext` takes the form of an `AccessibleAWTList`. A new `AccessibleAWTList` instance is created, if necessary.
    Specified by:
      `getAccessibleContext` in interface `Accessible`
    Overrides:
      `getAccessibleContext` in class `Component`
    Returns:
      an `AccessibleAWTList` that serves as the `AccessibleContext` of this `List`
    Since:
      1.3